#ifndef DEVICESELECTITEM_H
#define DEVICESELECTITEM_H

#include <QLabel>
#include <QPainter>
#include <QWidget>
#include <QStyle>
#include <QGSettings>
#include <QVariant>

#define TRANSPARENCY_SETTINGS       "org.ukui.control-center.personalise"
#define TRANSPARENCY_KEY            "transparency"

class DeviceSelectItem : public QLabel
{
    Q_OBJECT
public:
    DeviceSelectItem(QString name, QString address, QIcon icon, QWidget *parent);
    ~DeviceSelectItem();

    void setUnselectedState();
    void setSelectedState();
    QString getAddress();

    enum Status{
        Hover = 0,
        Normal,
        Click,
        Choose
    };
    Q_ENUM(Status)

    enum PixmapColor {
            WHITE = 0,
            BLACK,
            GRAY,
            BLUE,
    };
    Q_ENUM(PixmapColor)
    int FontTable[6] = {48, 44, 42, 40, 34, 32};
private:
    QIcon MIcon;
    QString MName;
    QString MAddress;
    Status _MStatus;

    QGSettings *StyleSettings = nullptr;
    QGSettings *transparency_gsettings = nullptr;
    double tran =1;
    bool choosed = false;

    QColor getPainterBrushColor();
    const QPixmap loadSvg(const QPixmap &source, const PixmapColor &cgColor);

protected:
    void enterEvent(QEvent *event);
    void leaveEvent(QEvent *event);
    void mousePressEvent(QMouseEvent *ev);
    void mouseReleaseEvent(QMouseEvent *ev);
    void paintEvent(QPaintEvent *);

signals:
    void clicked(QStringList);
    void unclicked();
};

#endif // DEVICESELECTITEM_H
